# Godot LiveLinkFace

This Godot extension allows user to connect Unreal LiveLinkFace iPhone app to the engine and control various parameters of nodes.

## Available nodes

### LiveLinkServer
This is a main node that handles incoming connections from the app.
Set "Listen IP" and "Listen Port" parameters to the ones set in the app configuration "UPD server"
If you have multiple sources of face data - add same number of LiveLinkServer nodes to the scene and set different listen port for each.

Other nodes depend on LiveLinkServer to be present in the scene

### FaceBone
This node allows to control bones of the mesh.
#### Parameters
- Read From: LiveLinkServer node to read incoming messages from
- Read Shape: Select which shape should be tracked by this node. (Ex. HeadYaw, JawOpen, etc.)
- Target Skeleton: Set the skeleton that should be controled by this node
- Target Bone: String name of the controled bone
- Clamp in Min and Clamp in Max: clamp incoming shape value to the specific range
- Clamp out Min and Clamp out Max: clamp final transform value (can be used to limit final transform range of the bone)
- Transform Axis: Which bone axis this node controls

### FaceData
This node allows to control arbitary position of Node3d
#### Parameters
- Read From: LiveLinkServer node to read incoming messages from
- Read Shape: Select which shape should be tracked by this node. (Ex. HeadYaw, JawOpen, etc.)
- Target: Set the Node3d that should be controled by this node
- Clamp in Min and Clamp in Max: clamp incoming shape value to the specific range
- Clamp out Min and Clamp out Max: clamp final transform value (can be used to limit final transform range of the bone)
- Transform Axis: Which axis this node controls

### FaceData
This node allows to control arbitary position of Node3d
#### Parameters
- Read From: LiveLinkServer node to read incoming messages from
- Read Shape: Select which shape should be tracked by this node. (Ex. HeadYaw, JawOpen, etc.)
- Target: Set the Node3d that should be controled by this node
- Clamp in Min and Clamp in Max: clamp incoming shape value to the specific range
- Clamp out Min and Clamp out Max: clamp final transform value (can be used to limit final transform range of the bone)
- Transform Axis: Which axis this node controls

### FaceProperty
This node allows to control any parameter of the node, given it takes number as a value
#### Parameters
- Read From: LiveLinkServer node to read incoming messages from
- Read Shape: Select which shape should be tracked by this node. (Ex. HeadYaw, JawOpen, etc.)
- Target Object: Set any node derived from the Object that should be controled by this node
- Target Property: String path of the controlled property
- Clamp in Min and Clamp in Max: clamp incoming shape value to the specific range
- Clamp out Min and Clamp out Max: clamp final transform value (can be used to limit final transform range of the bone)
